Package edu.hws.jcm.draw

# Class Panner

java.lang.Object
edu.hws.jcm.draw.Drawable
edu.hws.jcm.draw.Panner

All Implemented Interfaces:
  `MouseListener`, `MouseMotionListener`, `Serializable`, `EventListener`

public class Panner extends Drawable implements MouseListener, MouseMotionListener
When a Panner object is added to a CoordinateRect, it becomes possible to "grab" the coordinate rectangle and pan it (that is, slide it around by moving it with the mouse). By default, the user must right-click-and-drag to pan the coordinates, but this can be changed by providing an argument to the constructor. It is possible to set a Controller to be notified each time the mouse moves while the user is dragging. Alternatively, or in addition, you can set a Controller to be notified when the user finishes dragging. However, for the most part this is unnecessary, since the Drawables in the CoordinateRect will for the most part redraw themselves properly when the limits on the CoordinateRect change. However, if you have Computable objects that depend on the coordinate limits, then they will need to be recomputed. (This will be the case if you use value objects returned by the getValueObject() method in the CoordinateRect class.)

A Panner, p, is inactive if its "visible" property has been set to false. (This is done by calling p.setVisible(false).)

See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class edu.hws.jcm.draw.Drawable

`canvas, coords`

## Constructor Summary

Constructors
Constructor
Description
`Panner()`
Create a Panner object that will let the user pan the CoordinateRect that contains the Panner by right-clicking and dragging (or, on Macintosh, command-clicking).
`Panner(int modifierSet)`
Create a Panner object that will let the user click-and-drag to pan the CoordinateRect that contains the Panner.

## Method Summary

Modifier and Type
Method
Description
`void`
`draw(Graphics g, boolean coordsChanged)`
Override the abstract draw() method from the Drawable class.
`Controller`
`getOnFinishDrag()`
Get the Controller that is notified when the user finishs a drag.
`Controller`
`getOnUserAction()`
Get the Controller that is notified when the user moves the mouse during a drag.
`void`
`mouseClicked(MouseEvent evt)`
Responds to a mouse-click.
`void`
`mouseDragged(MouseEvent evt)`
Responds to a mouse-drag.
`void`
`mouseEntered(MouseEvent evt)`
Responds to a mouse-enter event.
`void`
`mouseExited(MouseEvent evt)`
Responds to a mouse-exit event.
`void`
`mouseMoved(MouseEvent evt)`
Responds when mouse moves.
`void`
`mousePressed(MouseEvent evt)`
Responds to a mouse-press.
`void`
`mouseReleased(MouseEvent evt)`
Responds to a mouse-release.
`void`
`setOnFinishDrag(Controller c)`
Set a Controller that will be notified (by calling its compute method) whenever the user finishes a drag operation.
`void`
`setOnUserAction(Controller c)`
Set a Controller that will be notified (by calling its compute method) whenever the user moves the mouse during a drag.
`protected void`
`setOwnerData(DisplayCanvas canvas, CoordinateRect coords)`
Called when this object is added to a DisplayCanvas.

### Methods inherited from class edu.hws.jcm.draw.Drawable

`getVisible, needsRedraw, setVisible`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Panner

public Panner()
Create a Panner object that will let the user pan the CoordinateRect that contains the Panner by right-clicking and dragging (or, on Macintosh, command-clicking).

### Panner

public Panner(int modifierSet)
Create a Panner object that will let the user click-and-drag to pan the CoordinateRect that contains the Panner. The mouse-pressed event must have the specfied set of modifiers set.

Parameters:
  `modifiers` - If the value is zero, the user drags the CoordinateRect by clicking without pressing any modifier keys. Otherwise, the value should be a combination of one or more of the constants MouseEvent.SHIFT_MASK, MouseEvent.CTRL_MASK, MouseEvent.META_MASK, and MouseEvent.ALT_MASK, or'ed together. (Remember that right-clicking sets META_MASK and clicking with a middle mouse button sets ALT_MASK.)

## Method Details

### setOnUserAction

public void setOnUserAction(Controller c)
Set a Controller that will be notified (by calling its compute method) whenever the user moves the mouse during a drag. If the value is null, no Controller is notified. Note that Drawables generally redraw themselvs correctly during the drag anyway, without any Controller being involved. Even if there are other things that need to be computed, it's probably better to compute them only once at the end of the drag. Do this by calling setOnFinishDrag() instead of this method.

### getOnUserAction

public Controller getOnUserAction()
Get the Controller that is notified when the user moves the mouse during a drag. Returns null if no Controller is notified.

### setOnFinishDrag

public void setOnFinishDrag(Controller c)
Set a Controller that will be notified (by calling its compute method) whenever the user finishes a drag operation. If the value is null, no Controller is notified. You only need to do this if you have to recompute some object that depends on the coordinate limits of the CoordinateRect that contains this Panner object. Presumably, this will be an object that depends on one if the Value objects returned by the getValueObject() method in the CoordinatRect class.

### getOnFinishDrag

public Controller getOnFinishDrag()
Get the Controller that is notified when the user finishs a drag. Returns null if no Controller is notified.

### setOwnerData

protected void setOwnerData(DisplayCanvas canvas, CoordinateRect coords)
Called when this object is added to a DisplayCanvas. Not meant to be called directly.

Overrides:
  `setOwnerData` in class `Drawable`

### draw

public void draw(Graphics g, boolean coordsChanged)
Override the abstract draw() method from the Drawable class. This is defined to be empty since a Panner object has no visible representation.

Specified by:
  `draw` in class `Drawable`
Parameters:
  `g` - The graphics context in which the Drawble is to be drawn. (The drawing can change the color in g, but should not permanently change font, painting mode, etc. Thus, every drawable is responsible for setting the color it wants to use.)
  `coordsChanged` - Indicates whether the CoordinateRect has changed.

### mousePressed

public void mousePressed(MouseEvent evt)
Responds to a mouse-press. Not meant to be called directly.

Specified by:
  `mousePressed` in interface `MouseListener`

### mouseDragged

public void mouseDragged(MouseEvent evt)
Responds to a mouse-drag. Not meant to be called directly.

Specified by:
  `mouseDragged` in interface `MouseMotionListener`

### mouseReleased

public void mouseReleased(MouseEvent evt)
Responds to a mouse-release. Not meant to be called directly.

Specified by:
  `mouseReleased` in interface `MouseListener`

### mouseClicked

public void mouseClicked(MouseEvent evt)
Responds to a mouse-click. Not meant to be called directly. Defined to be empty in this class.

Specified by:
  `mouseClicked` in interface `MouseListener`

### mouseMoved

public void mouseMoved(MouseEvent evt)
Responds when mouse moves. Not meant to be called directly. Defined to be empty in this class.

Specified by:
  `mouseMoved` in interface `MouseMotionListener`

### mouseEntered

public void mouseEntered(MouseEvent evt)
Responds to a mouse-enter event. Not meant to be called directly. Defined to be empty in this class.

Specified by:
  `mouseEntered` in interface `MouseListener`

### mouseExited

public void mouseExited(MouseEvent evt)
Responds to a mouse-exit event. Not meant to be called directly. Defined to be empty in this class.

Specified by:
  `mouseExited` in interface `MouseListener`